From 3fd88e8747d79c91d7fc6e6a50cea20a175232ad Mon Sep 17 00:00:00 2001
From: Antonin Houska <ah@cybertec.at>
Date: Wed, 11 Mar 2026 15:19:04 +0100
Subject: [PATCH 4/7] Serialize decoded tuples without flattening.

So far we used to flatten the tuples produced by logical decoding in order to
write them to a temporary file. That means that all the TOASTed attributes
ended up in a single chunk of memory. The problem is that even if individual
attributes do fit into the maximum chunk size (currently 1 GB), the whole
tuple is not guaranteed to fit.

The flattening might be a problem in the future anyway, since there's an
effort to restrict the impact of REPACK (CONCURRENTLY) on the VACUUM xmin
horizon. However, as the flattening assumes scans of the TOAST relaation, the
less we restrict VACUUM, the more likely it is that the TOAST attributes
needed for the flattening won't be available at decoding time.

(This patch also removes unnecessary field 'tupdesc' from RepackDecodingState
and allocates it in the appropriate memory context.)
---
 src/backend/commands/cluster.c                | 264 +++++++++++++++---
 .../pgoutput_repack/pgoutput_repack.c         | 123 +++++---
 src/include/commands/cluster.h                |   6 +-
 .../expected/repack_toast.out                 |   1 +
 .../injection_points/specs/repack_toast.spec  |   7 +
 5 files changed, 330 insertions(+), 71 deletions(-)

diff --git a/src/backend/commands/cluster.c b/src/backend/commands/cluster.c
index dcad236bd0a..d89be1b9533 100644
--- a/src/backend/commands/cluster.c
+++ b/src/backend/commands/cluster.c
@@ -33,6 +33,7 @@
 #include "postgres.h"
 
 #include "access/amapi.h"
+#include "access/detoast.h"
 #include "access/heapam.h"
 #include "access/multixact.h"
 #include "access/relscan.h"
@@ -286,6 +287,10 @@ static void apply_concurrent_update(Relation rel, HeapTuple tup,
 									IndexInsertState *iistate,
 									TupleTableSlot *index_slot);
 static void apply_concurrent_delete(Relation rel, HeapTuple tup_target);
+static HeapTuple restore_tuple(BufFile *file, Relation relation,
+							   MemoryContext cxt);
+static HeapTuple adjust_toast_pointers(Relation relation, HeapTuple tup_dst,
+									   HeapTuple tup_src, MemoryContext cxt);
 static HeapTuple find_target_tuple(Relation rel, ChangeDest *dest,
 								   HeapTuple tup_key,
 								   TupleTableSlot *ident_slot);
@@ -2619,6 +2624,7 @@ setup_logical_decoding(Oid relid)
 	LogicalDecodingContext *ctx;
 	NameData	slotname;
 	RepackDecodingState *dstate;
+	MemoryContext oldcxt;
 
 	/*
 	 * REPACK CONCURRENTLY is not allowed in a transaction block, so this
@@ -2669,14 +2675,6 @@ setup_logical_decoding(Oid relid)
 	 */
 	ctx->reader->routine.page_read = read_local_xlog_page_no_wait;
 
-	/*
-	 * read_local_xlog_page_no_wait() needs to be able to indicate the end of
-	 * WAL.
-	 */
-	ctx->reader->private_data = MemoryContextAllocZero(ctx->context,
-													   sizeof(ReadLocalXLogPageNoWaitPrivate));
-
-
 	/* Some WAL records should have been read. */
 	Assert(ctx->reader->EndRecPtr != InvalidXLogRecPtr);
 
@@ -2687,18 +2685,27 @@ setup_logical_decoding(Oid relid)
 	XLByteToSeg(ctx->reader->EndRecPtr, repack_current_segment,
 				wal_segment_size);
 
-	dstate = palloc0_object(RepackDecodingState);
-	dstate->relid = relid;
+	/* Our private state belongs to the decoding context. */
+	oldcxt = MemoryContextSwitchTo(ctx->context);
 
 	/*
-	 * Tuple descriptor may be needed to flatten a tuple before we write it to
-	 * a file. A copy is needed because the decoding worker invalidates system
-	 * caches before it starts to do the actual work.
+	 * read_local_xlog_page_no_wait() needs to be able to indicate the end of
+	 * WAL.
 	 */
-	rel = table_open(relid, AccessShareLock);
-	dstate->tupdesc = CreateTupleDescCopy(RelationGetDescr(rel));
+	ctx->reader->private_data = palloc0_object(ReadLocalXLogPageNoWaitPrivate);
+	dstate = palloc0_object(RepackDecodingState);
+	MemoryContextSwitchTo(oldcxt);
+
+#ifdef	USE_ASSERT_CHECKING
+	dstate->relid = relid;
+#endif
+
+	dstate->change_cxt = AllocSetContextCreate(ctx->context,
+											   "REPACK - change",
+											   ALLOCSET_DEFAULT_SIZES);
 
 	/* Avoid logical decoding of other relations. */
+	rel = table_open(relid, AccessShareLock);
 	repacked_rel_locator = rel->rd_locator;
 	toastrelid = rel->rd_rel->reltoastrelid;
 	if (OidIsValid(toastrelid))
@@ -2867,10 +2874,10 @@ static void
 apply_concurrent_changes(BufFile *file, ChangeDest *dest)
 {
 	char		kind;
-	uint32		t_len;
 	Relation	rel = dest->rel;
 	TupleTableSlot *index_slot,
 			   *ident_slot;
+	MemoryContext apply_cxt;
 	HeapTuple	tup_old = NULL;
 
 	/* TupleTableSlot is needed to pass the tuple to ExecInsertIndexTuples(). */
@@ -2880,6 +2887,14 @@ apply_concurrent_changes(BufFile *file, ChangeDest *dest)
 	/* A slot to fetch tuples from identity index. */
 	ident_slot = table_slot_create(rel, NULL);
 
+	/*
+	 * Use a separate memory context for the tuples and any memory needed to
+	 * process them.
+	 */
+	apply_cxt = AllocSetContextCreate(TopTransactionContext,
+									  "REPACK - apply",
+									  ALLOCSET_DEFAULT_SIZES);
+
 	while (true)
 	{
 		size_t		nread;
@@ -2894,14 +2909,7 @@ apply_concurrent_changes(BufFile *file, ChangeDest *dest)
 			break;
 
 		/* Read the tuple. */
-		BufFileReadExact(file, &t_len, sizeof(t_len));
-		tup = (HeapTuple) palloc(HEAPTUPLESIZE + t_len);
-		tup->t_data = (HeapTupleHeader) ((char *) tup + HEAPTUPLESIZE);
-		BufFileReadExact(file, tup->t_data, t_len);
-		tup->t_len = t_len;
-		ItemPointerSetInvalid(&tup->t_self);
-		tup->t_tableOid = RelationGetRelid(dest->rel);
-
+		tup = restore_tuple(file, rel, apply_cxt);
 		if (kind == CHANGE_UPDATE_OLD)
 		{
 			Assert(tup_old == NULL);
@@ -2913,7 +2921,7 @@ apply_concurrent_changes(BufFile *file, ChangeDest *dest)
 
 			apply_concurrent_insert(rel, tup, dest->iistate, index_slot);
 
-			pfree(tup);
+			MemoryContextReset(apply_cxt);
 		}
 		else if (kind == CHANGE_UPDATE_NEW || kind == CHANGE_DELETE)
 		{
@@ -2937,18 +2945,28 @@ apply_concurrent_changes(BufFile *file, ChangeDest *dest)
 				elog(ERROR, "failed to find target tuple");
 
 			if (kind == CHANGE_UPDATE_NEW)
+			{
+				/*
+				 * If 'tup' contains TOAST pointers, they point to the old
+				 * relation's toast. Copy the corresponding TOAST pointers for
+				 * the new relation from the existing tuple. (The fact that we
+				 * received a TOAST pointer here implies that the attribute
+				 * hasn't changed.)
+				 */
+				if (HeapTupleHasExternal(tup))
+					tup = adjust_toast_pointers(rel, tup, tup_exist,
+												apply_cxt);
+
 				apply_concurrent_update(rel, tup, tup_exist, dest->iistate,
 										index_slot);
+			}
 			else
 				apply_concurrent_delete(rel, tup_exist);
 
 			if (tup_old != NULL)
-			{
-				pfree(tup_old);
 				tup_old = NULL;
-			}
 
-			pfree(tup);
+			MemoryContextReset(apply_cxt);
 		}
 		else
 			elog(ERROR, "unrecognized kind of change: %d", kind);
@@ -2965,6 +2983,7 @@ apply_concurrent_changes(BufFile *file, ChangeDest *dest)
 	}
 
 	/* Cleanup. */
+	MemoryContextDelete(apply_cxt);
 	ExecDropSingleTupleTableSlot(index_slot);
 	ExecDropSingleTupleTableSlot(ident_slot);
 }
@@ -3074,6 +3093,186 @@ apply_concurrent_delete(Relation rel, HeapTuple tup_target)
 	pgstat_progress_incr_param(PROGRESS_REPACK_HEAP_TUPLES_DELETED, 1);
 }
 
+/*
+ * Read tuple from file and store it in given memory context.
+ *
+ * External attributes are stored in separate memory chunks, in order to avoid
+ * exceeding MaxAllocSize - that could happen if the individual attributes are
+ * smaller than MaxAllocSize but the whole tuple is bigger.
+ */
+static HeapTuple
+restore_tuple(BufFile *file, Relation relation, MemoryContext cxt)
+{
+	uint32		t_len;
+	HeapTuple	tup;
+	MemoryContext oldcxt;
+	uint32		natt_ext;
+	List	   *attrs_ext = NIL;
+
+	oldcxt = MemoryContextSwitchTo(cxt);
+
+	/* First, read the external attributes if there are some. */
+	BufFileReadExact(file, &natt_ext, sizeof(natt_ext));
+	for (int i = 0; i < natt_ext; i++)
+	{
+		alignas(uint32) varlena		varhdr;
+		char	   *ext_val;
+		Size		ext_val_size;
+
+		/*
+		 * Read the header into properly aligned memory before accessing it.
+		 */
+		BufFileReadExact(file, &varhdr, VARHDRSZ);
+		ext_val_size = VARSIZE_ANY(&varhdr);
+		ext_val = palloc0(ext_val_size);
+		memcpy(ext_val, &varhdr, VARHDRSZ);
+		BufFileReadExact(file, ext_val + VARHDRSZ, ext_val_size - VARHDRSZ);
+
+		attrs_ext = lappend(attrs_ext, ext_val);
+	}
+
+	/* Read the tuple. */
+	BufFileReadExact(file, &t_len, sizeof(t_len));
+	tup = (HeapTuple) palloc(HEAPTUPLESIZE + t_len);
+	tup->t_data = (HeapTupleHeader) ((char *) tup + HEAPTUPLESIZE);
+	BufFileReadExact(file, tup->t_data, t_len);
+	tup->t_len = t_len;
+	ItemPointerSetInvalid(&tup->t_self);
+	tup->t_tableOid = RelationGetRelid(relation);
+
+	/*
+	 * If there are "external indirect" attributes, make the tuple reference
+	 * them.
+	 */
+	if (natt_ext > 0)
+	{
+		TupleDesc	desc;
+		Datum	   *attrs;
+		bool	   *isnull;
+		ListCell   *lc;
+
+		desc = RelationGetDescr(relation);
+		attrs = palloc0_array(Datum, desc->natts);
+		isnull = palloc0_array(bool, desc->natts);
+
+		heap_deform_tuple(tup, desc, attrs, isnull);
+
+		lc = list_head(attrs_ext);
+		for (int i = 0; i < desc->natts; i++)
+		{
+			CompactAttribute *attr = TupleDescCompactAttr(desc, i);
+			varlena    *varlena_pointer,
+					   *new_datum;
+			varatt_indirect redirect_pointer;
+
+			/* Find the external attributes, like in store_change(). */
+			if (attr->attisdropped)
+				continue;
+			if (attr->attlen != -1)
+				continue;
+			if (isnull[i])
+				continue;
+			varlena_pointer = (varlena *) DatumGetPointer(attrs[i]);
+			if (!VARATT_IS_EXTERNAL_INDIRECT(varlena_pointer))
+				continue;
+
+			/* Update the attribute. */
+			memset(&redirect_pointer, 0, sizeof(redirect_pointer));
+			redirect_pointer.pointer = lfirst(lc);
+
+			new_datum = (varlena *) palloc0(INDIRECT_POINTER_SIZE);
+			SET_VARTAG_EXTERNAL(new_datum, VARTAG_INDIRECT);
+			memcpy(VARDATA_EXTERNAL(new_datum), &redirect_pointer,
+				   sizeof(redirect_pointer));
+
+			attrs[i] = PointerGetDatum(new_datum);
+
+			lc = lnext(attrs_ext, lc);
+		}
+		Assert(lc == NULL);
+
+		tup = heap_form_tuple(desc, attrs, isnull);
+	}
+
+	MemoryContextSwitchTo(oldcxt);
+
+	return tup;
+}
+
+/*
+ * Copy TOAST pointers from 'tup_src' to 'tup_dst' and return the modified
+ * 'tup_dst'. Use 'cxt' for all memory allocations.
+ */
+static HeapTuple
+adjust_toast_pointers(Relation relation, HeapTuple tup_dst,
+					  HeapTuple tup_src, MemoryContext cxt)
+{
+	TupleDesc	desc;
+	Datum	   *attrs_dst;
+	bool	   *isnull_dst;
+	Datum	   *attrs_src = NULL;
+	bool	   *isnull_src = NULL;
+	MemoryContext oldcxt;
+	HeapTuple	result;
+
+	oldcxt = MemoryContextSwitchTo(cxt);
+
+	desc = RelationGetDescr(relation);
+	attrs_dst = palloc0_array(Datum, desc->natts);
+	isnull_dst = palloc0_array(bool, desc->natts);
+
+	heap_deform_tuple(tup_dst, desc, attrs_dst, isnull_dst);
+
+	for (int i = 0; i < desc->natts; i++)
+	{
+		CompactAttribute *attr = TupleDescCompactAttr(desc, i);
+		varlena    *varlena_dst,
+				   *varlena_src;
+
+		if (attr->attisdropped)
+			continue;
+		if (attr->attlen != -1)
+			continue;
+		if (isnull_dst[i])
+			continue;
+
+		varlena_dst = (varlena *) DatumGetPointer(attrs_dst[i]);
+		if (!VARATT_IS_EXTERNAL_ONDISK(varlena_dst))
+			continue;
+
+		/*
+		 * The first TOAST pointer? The caller can easily check if the tuple
+		 * has external attributes(s) in general, but is not supposed to check
+		 * specifically for TOAST.
+		 */
+		if (attrs_src == NULL)
+		{
+			attrs_src = palloc0_array(Datum, desc->natts);
+			isnull_src = palloc0_array(bool, desc->natts);
+
+			heap_deform_tuple(tup_src, desc, attrs_src, isnull_src);
+		}
+
+		varlena_src = (varlena *) DatumGetPointer(attrs_src[i]);
+
+		/*
+		 * Logical decoding only uses TOAST pointer for attributes that
+		 * haven't changed.
+		 */
+		Assert(!isnull_src[i]);
+		Assert(VARATT_IS_EXTERNAL_ONDISK(varlena_src));
+
+		/* Copy the pointer. */
+		memcpy(VARDATA_EXTERNAL(varlena_dst), VARDATA_EXTERNAL(varlena_src),
+			   sizeof(varatt_external));
+	}
+	result = heap_form_tuple(desc, attrs_dst, isnull_dst);
+
+	MemoryContextSwitchTo(oldcxt);
+
+	return result;
+}
+
 /*
  * Find the tuple to be updated or deleted.
  *
@@ -3296,15 +3495,8 @@ free_index_insert_state(IndexInsertState *iistate)
 static void
 cleanup_logical_decoding(LogicalDecodingContext *ctx)
 {
-	RepackDecodingState *dstate;
-
-	dstate = (RepackDecodingState *) ctx->output_writer_private;
-
-	FreeTupleDesc(dstate->tupdesc);
 	FreeDecodingContext(ctx);
-
 	ReplicationSlotDropAcquired();
-	pfree(dstate);
 }
 
 /*
diff --git a/src/backend/replication/pgoutput_repack/pgoutput_repack.c b/src/backend/replication/pgoutput_repack/pgoutput_repack.c
index d0c464a98d5..90f3a8975b9 100644
--- a/src/backend/replication/pgoutput_repack/pgoutput_repack.c
+++ b/src/backend/replication/pgoutput_repack/pgoutput_repack.c
@@ -12,7 +12,7 @@
  */
 #include "postgres.h"
 
-#include "access/heaptoast.h"
+#include "access/detoast.h"
 #include "commands/cluster.h"
 #include "replication/snapbuild.h"
 #include "utils/memutils.h"
@@ -28,7 +28,7 @@ static void plugin_commit_txn(LogicalDecodingContext *ctx,
 							  ReorderBufferTXN *txn, XLogRecPtr commit_lsn);
 static void plugin_change(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
 						  Relation rel, ReorderBufferChange *change);
-static void store_change(LogicalDecodingContext *ctx,
+static void store_change(LogicalDecodingContext *ctx, Relation relation,
 						 ConcurrentChangeKind kind, HeapTuple tuple);
 
 void
@@ -93,13 +93,9 @@ static void
 plugin_change(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
 			  Relation relation, ReorderBufferChange *change)
 {
-	RepackDecodingState *dstate;
-
-	dstate = (RepackDecodingState *) ctx->output_writer_private;
-
-	/* Only interested in one particular relation. */
-	if (relation->rd_id != dstate->relid)
-		return;
+	/* Changes of other relation should not have been decoded. */
+	Assert(RelationGetRelid(relation) ==
+		   ((RepackDecodingState *) ctx->output_writer_private)->relid);
 
 	/* Decode entry depending on its type */
 	switch (change->action)
@@ -117,7 +113,7 @@ plugin_change(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
 				if (newtuple == NULL)
 					elog(ERROR, "incomplete insert info.");
 
-				store_change(ctx, CHANGE_INSERT, newtuple);
+				store_change(ctx, relation, CHANGE_INSERT, newtuple);
 			}
 			break;
 		case REORDER_BUFFER_CHANGE_UPDATE:
@@ -132,9 +128,9 @@ plugin_change(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
 					elog(ERROR, "incomplete update info.");
 
 				if (oldtuple != NULL)
-					store_change(ctx, CHANGE_UPDATE_OLD, oldtuple);
+					store_change(ctx, relation, CHANGE_UPDATE_OLD, oldtuple);
 
-				store_change(ctx, CHANGE_UPDATE_NEW, newtuple);
+				store_change(ctx, relation, CHANGE_UPDATE_NEW, newtuple);
 			}
 			break;
 		case REORDER_BUFFER_CHANGE_DELETE:
@@ -146,7 +142,7 @@ plugin_change(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
 				if (oldtuple == NULL)
 					elog(ERROR, "incomplete delete info.");
 
-				store_change(ctx, CHANGE_DELETE, oldtuple);
+				store_change(ctx, relation, CHANGE_DELETE, oldtuple);
 			}
 			break;
 		default:
@@ -164,39 +160,100 @@ plugin_change(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
 
 /* Store concurrent data change. */
 static void
-store_change(LogicalDecodingContext *ctx, ConcurrentChangeKind kind,
-			 HeapTuple tuple)
+store_change(LogicalDecodingContext *ctx, Relation relation,
+			 ConcurrentChangeKind kind, HeapTuple tuple)
 {
 	RepackDecodingState *dstate;
+	MemoryContext	oldcxt;
+	BufFile    *file;
 	char		kind_byte = (char) kind;
-	bool		flattened = false;
+	List	   *attrs_ext = NIL;
+	uint32		natt_ext;
 
 	dstate = (RepackDecodingState *) ctx->output_writer_private;
+	file = dstate->file;
 
 	/* Store the change kind. */
-	BufFileWrite(dstate->file, &kind_byte, 1);
+	BufFileWrite(file, &kind_byte, 1);
+
+	/* Make sure there are no memory leaks. */
+	oldcxt = MemoryContextSwitchTo(dstate->change_cxt);
 
 	/*
-	 * ReorderBufferCommit() stores the TOAST chunks in its private memory
-	 * context and frees them after having called apply_change().  Therefore
-	 * we need flat copy (including TOAST) that we eventually copy into the
-	 * memory context which is available to decode_concurrent_changes().
+	 * If the tuple contains "external indirect" attributes, we need to write
+	 * the contents to the file because we have no control over that memory.
 	 */
 	if (HeapTupleHasExternal(tuple))
 	{
-		/*
-		 * toast_flatten_tuple_to_datum() might be more convenient but we
-		 * don't want the decompression it does.
-		 */
-		tuple = toast_flatten_tuple(tuple, dstate->tupdesc);
-		flattened = true;
+		TupleDesc	desc;
+		Datum	   *attrs;
+		bool	   *isnull;
+
+		desc = RelationGetDescr(relation);
+		attrs = palloc0_array(Datum, desc->natts);
+		isnull = palloc0_array(bool, desc->natts);
+
+		heap_deform_tuple(tuple, desc, attrs, isnull);
+
+		/* First, gather and count the "external indirect" attributes. */
+		for (int i = 0; i < desc->natts; i++)
+		{
+			CompactAttribute *attr = TupleDescCompactAttr(desc, i);
+			varlena    *varlena_pointer;
+
+			if (attr->attisdropped)
+				continue;
+
+			/* not a varlena datatype */
+			if (attr->attlen != -1)
+				continue;
+
+			/* no data */
+			if (isnull[i])
+				continue;
+
+			/* ok, we know we have a toast datum */
+			varlena_pointer = (varlena *) DatumGetPointer(attrs[i]);
+
+			if (!VARATT_IS_EXTERNAL(varlena_pointer))
+				continue;
+
+			if (VARATT_IS_EXTERNAL_INDIRECT(varlena_pointer))
+				attrs_ext = lappend(attrs_ext, varlena_pointer);
+			else
+			{
+				/*
+				 * Logical decoding should not produce "external expanded"
+				 * attributes (those actually should never appear on disk), so
+				 * only TOASTed attribute can be seen here.
+				 */
+				Assert(VARATT_IS_EXTERNAL_ONDISK(varlena_pointer));
+			}
+		}
+		natt_ext = list_length(attrs_ext);
 	}
-	/* Store the tuple size ... */
-	BufFileWrite(dstate->file, &tuple->t_len, sizeof(tuple->t_len));
+	else
+		natt_ext = 0;
+
+	/* Write the number of external attributes. */
+	BufFileWrite(file, &natt_ext, sizeof(natt_ext));
+	/* ... and the attributes themselves, if there are some. */
+	foreach_ptr(varlena, attr_val, attrs_ext)
+	{
+		varlena    *ext_val;
+		Size		ext_val_size;
+
+		ext_val = detoast_external_attr(attr_val);
+		ext_val_size = VARSIZE_ANY(ext_val);
+		BufFileWrite(file, ext_val, ext_val_size);
+	}
+
+	/* Finally write the tuple size ... */
+	BufFileWrite(file, &tuple->t_len, sizeof(tuple->t_len));
 	/* ... and the tuple itself. */
-	BufFileWrite(dstate->file, tuple->t_data, tuple->t_len);
+	BufFileWrite(file, tuple->t_data, tuple->t_len);
 
-	/* Free the flat copy if created above. */
-	if (flattened)
-		pfree(tuple);
+	/* Cleanup. */
+	MemoryContextSwitchTo(oldcxt);
+	MemoryContextReset(dstate->change_cxt);
 }
diff --git a/src/include/commands/cluster.h b/src/include/commands/cluster.h
index 1b05d5d418b..34b7208de9b 100644
--- a/src/include/commands/cluster.h
+++ b/src/include/commands/cluster.h
@@ -65,11 +65,13 @@ typedef enum
  */
 typedef struct RepackDecodingState
 {
+#ifdef	USE_ASSERT_CHECKING
 	/* The relation whose changes we're decoding. */
 	Oid			relid;
+#endif
 
-	/* Tuple descriptor of the relation being processed. */
-	TupleDesc	tupdesc;
+	/* Per-change memory context. */
+	MemoryContext	change_cxt;
 
 	/* The current output file. */
 	BufFile    *file;
diff --git a/src/test/modules/injection_points/expected/repack_toast.out b/src/test/modules/injection_points/expected/repack_toast.out
index 4f866a74e32..b56dde134f8 100644
--- a/src/test/modules/injection_points/expected/repack_toast.out
+++ b/src/test/modules/injection_points/expected/repack_toast.out
@@ -13,6 +13,7 @@ step change:
 	UPDATE repack_test SET j=get_long_string() where i=2;
 	DELETE FROM repack_test WHERE i=3;
 	INSERT INTO repack_test(i, j) VALUES (4, get_long_string());
+	UPDATE repack_test SET i=3 where i=1;
 
 step check2: 
 	INSERT INTO relfilenodes(node)
diff --git a/src/test/modules/injection_points/specs/repack_toast.spec b/src/test/modules/injection_points/specs/repack_toast.spec
index b48abf21450..b878b198971 100644
--- a/src/test/modules/injection_points/specs/repack_toast.spec
+++ b/src/test/modules/injection_points/specs/repack_toast.spec
@@ -74,10 +74,17 @@ teardown
 
 session s2
 step change
+# Separately test UPDATE of both plain ("i") and TOASTed ("j") attribute. In
+# the first case, the new tuple we get from reorderbuffer.c contains "j" as a
+# TOAST pointer, which we need to update so it points to the new heap. In the
+# latter case, we receive "j" as "external indirect" value - here we test that
+# the decoding worker writes the tuple to a file correctly and that the
+# backend executing REPACK manages to restore it.
 {
 	UPDATE repack_test SET j=get_long_string() where i=2;
 	DELETE FROM repack_test WHERE i=3;
 	INSERT INTO repack_test(i, j) VALUES (4, get_long_string());
+	UPDATE repack_test SET i=3 where i=1;
 }
 # Check the table from the perspective of s2.
 step check2
-- 
2.47.3

